from Numeric import *
import sys, os
#import RandomArray
import dca_lib

class dca:
    def __init__(self, data, data_classes, nclasses, A, initial_W, pdf_sigma, use_angle_reparameterization):
	self.pdf_sigma=pdf_sigma
        self.MW=dca_lib.initialize(data,data_classes,nclasses,A,initial_W,pdf_sigma,use_angle_reparameterization)
        print 'Python: checking shape\n'
        print self.MW.shape
        self.original_W  = initial_W

    def gradient(self,MW):
	"""
	Gradient of the M and W parameters
        1-d representation of MW and the gradient.
	"""
        print 'Python: Calculating gradient\n'
        grad=dca_lib.gradient(MW) 
        return -grad # Cost function to be minimized = -1*log_likelihoog

    def singlepoint_gradient(self,MW,x_index):
	"""
	Gradient of the M and W parameters
        1-d representation of MW and the gradient.
	"""
        # print 'Python: Calculating gradient\n'
        grad=dca_lib.singlepoint_gradient(MW,x_index) 
        return -grad # Cost function to be minimized = -1*log_likelihoog

    def cost(self,MW):
        # print 'Python: cost\n'
        dcacost=dca_lib.cost(MW) # Log-likelihood 
        print dcacost
        return -dcacost # Cost function to be minimized = -1*log_likelihood

    def optimize(self,nCgradIters,nSecantIters):
        print 'Python: optimize\n'
        initMW=self.MW
        print initMW.shape
        MW=dca_lib.optimize(initMW,nCgradIters,nSecantIters)
        #print self.original_W.shape
        #MW=dca_lib.optimize(self.original_W,nCgradIters,nSecantIters)
        self.MW=MW
        cost=self.cost(self.MW)
        return cost

    def write_model(self,filename):
        dca_lib.save_projection(self.MW,filename)
        
if __name__=='__main__':
    note('The Python file dca.py should not be used as the main file, instead call learn_dca.py\n')
    
